#ifndef _ygKeyDatabase_h_
#define _ygKeyDatabase_h_

#include <stdio.h>
#include "ygString.h"


class ygKeyDatabase
	{
	public:
	 ygKeyDatabase(void);
	 void * get(const ygString& path, const ygString& key, size_t *size);
	 void store(const ygString& path, const ygString& key, void *data, size_t size);
	 void printContents(FILE *);
	 void printStats(void);
	 void sendContents(class CAVERNnet_tcpReflectorClient_c *client);
	private:
	 struct _ygKeyDatabasePrivateData * p_;
	 void sendKeyStruct(CAVERNnet_tcpReflectorClient_c *client,
			const ygString& path, const ygString& key,
			class ygKeyDatabaseKey *keystruct,
			class CAVERNnet_datapack_c *packer);
	};


#endif
