/*
 * Ygdrasil Version 0.1.7
 */
#ifndef _ygEvent_h_
#define _ygEvent_h_

#include "ygString.h"


class ygEvent
	{
	public:
	 ygString event;
	
	 friend inline bool operator==(const ygEvent& a,const ygString& b)
		{ return a.event == b; }
	 friend inline bool operator==(const ygString& a,const ygEvent& b)
		{ return a == b.event; }

	 ygEvent(const ygString& name,const ygString& args);
	 ygEvent& operator=(const ygEvent& other);
	 ~ygEvent(void);
	 void parseArgs(const ygString& str);
	 const ygString& argValue(const ygString&) const;
	 void addArg(const ygString& arg,const ygString& val);
	private:
	 struct _ygEventPrivateData *p_;
	};

#endif
